import java.time.*;

public class courtsOffice extends structModel{
    private boolean c5x5;
    private boolean c7x7;
    private boolean cp;
    private bank bk;
    
    /////////////////////////////// Inicializators    
    public courtsOffice(String nombre,float pos_x,float pos_y, databaseManager baseDeDatos, boolean C5x5, boolean C7x7, boolean Cp, bank banco){
        super(nombre,pos_x,pos_y,baseDeDatos);
        this.c5x5 = C5x5;
        this.c7x7 = C7x7;
        this.cp = Cp;
        this.bk = banco;
    }
    
    /////////////////////////////// Methods
    
    // this method will get a reservation of a court if all conditions are met. those are:
    //  -that court is not rented by another person at that time
    //  -that person has no debts with this institution
    //  -that person has not anoter reservation on the reservations sheet
    //  -the reservation is not done for the past

    public void reservateCourt(LocalDateTime now, String courtName, String name, String ID, String when){
        String codeID = "";
        String formattedDate = "";
        String[] whenDayTime;
        String[] whenDay;
        String[] whenTime;

        whenDayTime = when.split("-");
        whenTime = whenDayTime[0].split(":");
        whenDay = whenDayTime[1].split("/");

        if (this.isInTheFuture(when,now) && !this.hasNotAnotherReservation(ID) && !this.hasAnyDebtToUs(ID) && !this.courtIsAvilable(courtName,when)){
            codeID = codeID + String.valueOf(now.getYear());
            if (now.getMonthValue()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getMonthValue());
            if (now.getDayOfMonth()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getDayOfMonth());
            if (now.getHour()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getHour());
            if (now.getMinute()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getMinute());
            if (now.getSecond()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getSecond());
            if (now.getNano()/100000<10) codeID = codeID + "0";
            if (now.getNano()/100000<100) codeID = codeID + "0";
            if (now.getNano()/100000<1000) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getNano()/100000);


            if (now.getHour()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getHour()) + ":";
            if (now.getMinute()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getMinute()) + ":";
            if (now.getDayOfMonth()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getDayOfMonth())+ "/";
            if (now.getMonthValue()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getMonthValue())+ "/";
            formattedDate = formattedDate + String.valueOf(now.getYear());

            this.database.pushInfo(new String[] {codeID, formattedDate, when, courtName, name, ID});
        }
    }

    // this methdod checks if the court is rented by another person at some time
    private boolean courtIsAvilable(String courtName, String when){
        int[] reservationsAtThatHour;
        reservationsAtThatHour = this.database.lookForID(when, 2);
        for (int i : reservationsAtThatHour) {
            if (this.database.pullInfo(i)[3].equals(courtName)) return false;
        }
        return true;
    }

    // this methdod checks if a date is or not at the future
    private boolean isInTheFuture(String when,LocalDateTime now){
        String[] whenDayTime;
        String[] whenDay;
        String[] whenTime;
        long whenInMinutes;
        long nowInMinutes;

        whenDayTime = when.split("-");
        whenTime = whenDayTime[0].split(":");
        whenDay = whenDayTime[1].split("/");

        whenInMinutes = Integer.valueOf(whenDay[2])*60*60*24*30*12 + Integer.valueOf(whenDay[1])*60*60*24*30 + Integer.valueOf(whenDay[0])*60*60*24;
        whenInMinutes = whenInMinutes + Integer.valueOf(whenTime[0])*60*60 + Integer.valueOf(whenTime[1])*60;

        nowInMinutes = now.getYear()*60*60*24*30*12 + now.getMonthValue()*60*60*24*30 + now.getDayOfMonth()*60*60*24;
        nowInMinutes = nowInMinutes + now.getHour()*60*60 + now.getMinute()*60;

        if (whenInMinutes > nowInMinutes) return true;
        return false;
    }

    // this methdod checks if a date is or not at the future, giving the present some minute offset
    private boolean isInTheFuture(String when,LocalDateTime now, int nowOffsetInMinutes){
        String[] whenDayTime;
        String[] whenDay;
        String[] whenTime;
        long whenInMinutes;
        long nowInMinutes;

        whenDayTime = when.split("-");
        whenTime = whenDayTime[0].split(":");
        whenDay = whenDayTime[1].split("/");

        whenInMinutes = Integer.valueOf(whenDay[2])*60*60*24*30*12 + Integer.valueOf(whenDay[1])*60*60*24*30 + Integer.valueOf(whenDay[0])*60*60*24;
        whenInMinutes = whenInMinutes + Integer.valueOf(whenTime[0])*60*60 + Integer.valueOf(whenTime[1])*60;

        nowInMinutes = now.getYear()*60*60*24*30*12 + now.getMonthValue()*60*60*24*30 + now.getDayOfMonth()*60*60*24;
        nowInMinutes = nowInMinutes + now.getHour()*60*60 + now.getMinute()*60 + nowOffsetInMinutes;

        if (whenInMinutes > nowInMinutes) return true;
        return false;
    }

    // this methdod checks that a person does not has any other reservation
    private boolean hasNotAnotherReservation(String ID){
        if (database.lookForID(ID,5).length == 0) return false;
        return true;
    }

    // this methdod checks if a person checked for the reserved court at time
    public void markAsistence(String ID, LocalDateTime now, int OffsetInMinutes, int latePenalty){
        String[] reservation;

        if (database.lookForID(ID,5).length == 0) return;
        reservation = database.pullInfo(database.lookForID(ID,5)[0]);
        if (!this.isInTheFuture(reservation[2], now, -OffsetInMinutes)){ // this is true if the person arrives too late to the reserved court
            this.database.deleteInfo(this.database.lookForID(ID, 5)[0]);
            bk.addDebt(ID,this.name,latePenalty);
        }
        else{
            if (!this.isInTheFuture(reservation[2], now, OffsetInMinutes) && this.isInTheFuture(reservation[2], now, -OffsetInMinutes)){ 
                // this is true if the person arrives a little earlier, at time or a little late
                this.database.deleteInfo(this.database.lookForID(ID, 5)[0]);
                return;
            }
            else{
                // this will be executed if the person checks the court too early
                return;
            }
        }
        bk.addDebt(ID,this.name,latePenalty);
        this.database.deleteInfo(reservation[0]);
    }

    // this method will check if a person owes money to the courtsOffice
    public boolean hasAnyDebtToUs(String ID){
        int[] deudasID;
        String[] datosDeudaID;

        deudasID = bk.database.lookForID(ID);
        for (int i : deudasID) {
            datosDeudaID = bk.database.pullInfo(i);
            if (datosDeudaID[1]==this.name) return true;
        }
        return false;
    }
}