import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Random;
import java.util.stream.Collectors;

class StateMachineController {
    private bank caja;
    private entrance placeres;
    private entrance portales;
    private entrance espania;
    private entrance valdes;
    private courtsOffice torre;
    private databaseManager TUIs;

    private MachineState status;
    private BufferedReader keyboardInput;

    private String input;
    private String input_state = "";
    private String insideWhileInput;
    private String info;

    private String mainMenuMessage = "\n";
    private String webLogMenuMessage = "\n";
    private String simulationLogMenuMessage = "\n";
    private String webServicesMenuMessage = "\n";
    private String simulationMenuMessage = "\n";
    private String simulationMessageInsideCampus = "\n";
    private String simulationLeavingCampusMenuMessage = "\n";
    private String simulationSelectSportsCourtMessage = "\n";

    private String horariosCancha = "\n";
    private String diasSemana = "\n";

    private boolean mainMenu;
    private boolean paying;
    private boolean renting;
    private boolean simInsideTheCampus;

    private boolean nextStage;
    private boolean firstflag = false;

    private person user = new person("", 0, 0, 0);
    private String userID = "";
    private int key;
    private String[] answer = new String[2];

    private static MainScreen screen;



    public StateMachineController(bank caj, entrance placere, entrance portale, entrance espani, entrance valde,
            courtsOffice torr, databaseManager TUIdata, MainScreen pantalla) {
        caja = caj;
        placeres = placere;
        portales = portale;
        espania = espani;
        valdes = valde;
        torre = torr;
        TUIs = TUIdata;
        screen = pantalla;
    }

    public void controlar() throws IOException {
        if (true){
            mainMenuMessage = mainMenuMessage + "Bienvenido al menu principal de la plataforma ELO-329\n";
            mainMenuMessage = mainMenuMessage + "Para seleccionar una opcion escriba su numero seguido de un enter.\n";
            mainMenuMessage = mainMenuMessage + "elija una opcion\n";
            mainMenuMessage = mainMenuMessage + "1 - Entrar al servicio web\n";
            mainMenuMessage = mainMenuMessage + "2 - Ir a la universidad\n";
            mainMenuMessage = mainMenuMessage + "3 - Salir\n";
    
            webLogMenuMessage = webLogMenuMessage + "Bienvenido al servidor web de la plataforma ELO-329\n";
            webLogMenuMessage = webLogMenuMessage + "elija una opcion\n";
            webLogMenuMessage = webLogMenuMessage + "1 - Iniciar sesion\n";
            webLogMenuMessage = webLogMenuMessage + "2 - Registarse\n";
            webLogMenuMessage = webLogMenuMessage + "3 - Volver al menu principal\n";
    
            webServicesMenuMessage = webServicesMenuMessage + "Ha entrado al servidor web exitosamente\n";
            webServicesMenuMessage = webServicesMenuMessage + "elija una opcion\n";
            webServicesMenuMessage = webServicesMenuMessage + "1 - Pagar una deuda\n";
            webServicesMenuMessage = webServicesMenuMessage + "2 - Reservar una cancha\n";
            webServicesMenuMessage = webServicesMenuMessage + "3 - Verificar horas invertidas en el campus este año\n";
            webServicesMenuMessage = webServicesMenuMessage + "4 - Cerrar sesion\n";
    
            simulationLogMenuMessage = simulationLogMenuMessage + "Bienvenido al menu de simulacion de la universidad de la plataforma ELO-329\n";
            simulationLogMenuMessage = simulationLogMenuMessage + "elija una opcion\n";
            simulationLogMenuMessage = simulationLogMenuMessage + "1 - Ingresar\n";
            simulationLogMenuMessage = simulationLogMenuMessage + "2 - Registrarse\n";
            simulationLogMenuMessage = simulationLogMenuMessage + "3 - Volver al menu principal\n";
    
            simulationMenuMessage = simulationMenuMessage + "Usted se encuentra fuera del campus\n";
            simulationMenuMessage = simulationMenuMessage + "elija una opcion\n";
            simulationMenuMessage = simulationMenuMessage + "1 - Entrar al campus via Placeres\n";
            simulationMenuMessage = simulationMenuMessage + "2 - Entrar al campus via Portales\n";
            simulationMenuMessage = simulationMenuMessage + "3 - Entrar al campus via Espania\n";
            simulationMenuMessage = simulationMenuMessage + "4 - Entrar al campus via Valdes\n";
            simulationMenuMessage = simulationMenuMessage + "5 - Volver al menu principal\n";
    
            simulationMessageInsideCampus = simulationMessageInsideCampus + "Usted se encuentra dentro del campus\n";
            simulationMessageInsideCampus = simulationMessageInsideCampus + "elija una opcion\n";
            simulationMessageInsideCampus = simulationMessageInsideCampus + "1 - Dirigirse hacia una cancha\n";
            simulationMessageInsideCampus = simulationMessageInsideCampus + "2 - Salir del campus\n";
    
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "Usted esta saliendo del campus\n";
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "elija una opcion\n";
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "1 - Salir del campus via Placeres\n";
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "2 - Salir del campus via Portales\n";
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "3 - Salir del campus via Valdes\n";
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "4 - Salir del campus via Espania\n";
            simulationLeavingCampusMenuMessage = simulationLeavingCampusMenuMessage + "5 - Cancel\n";
    
            simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "Usted se dirije a una cancha\n";
            simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "elija una opcion\n";
            simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "1 - Ir a la cancha 5x5\n";
            simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "2 - Ir a la cancha 7x7\n";
            simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "3 - Ir a la cancha de pasto\n";
            simulationSelectSportsCourtMessage = simulationSelectSportsCourtMessage + "4 - Cancel\n";
    
            /////////////////////////////////////////
            horariosCancha = horariosCancha + "01 - 08:00\n";
            horariosCancha = horariosCancha + "02 - 09:00\n";
            horariosCancha = horariosCancha + "03 - 10:00\n";
            horariosCancha = horariosCancha + "04 - 11:00\n";
            horariosCancha = horariosCancha + "05 - 12:00\n";
            horariosCancha = horariosCancha + "06 - 13:00\n";
            horariosCancha = horariosCancha + "07 - 14:00\n";
            horariosCancha = horariosCancha + "08 - 15:00\n";
            horariosCancha = horariosCancha + "09 - 16:00\n";
            horariosCancha = horariosCancha + "10 - 17:00\n";
            horariosCancha = horariosCancha + "11 - 18:00\n";
            horariosCancha = horariosCancha + "12 - 19:00\n";
            horariosCancha = horariosCancha + "13 - 20:00\n";
            horariosCancha = horariosCancha + "14 - No arrendar\n";
    
            diasSemana = diasSemana + "1 - Lunes\n";
            diasSemana = diasSemana + "2 - Martes\n";
            diasSemana = diasSemana + "3 - Miercoles\n";
            diasSemana = diasSemana + "4 - Jueves\n";
            diasSemana = diasSemana + "5 - Viernes\n";
            diasSemana = diasSemana + "6 - Sabado\n";
        }
        ///////////// this is the main menu
        mainMenu = true;
        status = MachineState.MAIN;
        while (mainMenu){
            switch (status) {
                case MAIN: 
                    screen.setVisiblePanel("Main menu");
                    status = screen.getStatus();
                    break;

                case WEBLOG: ///////////// this is the web page's menu
                    screen.setVisiblePanel("WebLogMenu");
                    status = screen.getStatus();
                    break;

                case SIMLOG:///////////// this is the simulation menu
                    screen.setVisiblePanel("SimLogMenu");
                    status = screen.getStatus();
                    break;

                case LOGIN:
                    screen.setVisiblePanel("Log in");
                    /*answer = this.LogIN(input_state);
                    if (answer[1] != ""){ ///////////// if login is successful
                        user = new person(TUIs.pullInfo(answer[1])[1],8,8,1994,5000,new TUI(TUIs.pullInfo(answer[1])[1], 1, Integer.valueOf(answer[1])));
                        userID = Integer.toString(user.getTUI().getID());
                    }*/
                    status = screen.getStatus();
                    break;

                case REGISTER:
                    screen.setVisiblePanel("Register");
                    status = screen.getStatus();
                    //this.Register();
                    break;
            
                case WEB:
                    screen.setVisiblePanel("Web");
                    status = screen.getStatus();
                    if (screen.getFlag(0)){
                        screen.sendPopup(caja.getSomeonesDebts(userID).stream().map(Object::toString).collect(Collectors.joining("\n")));
                        screen.resetFlag(0);
                    }
                    /*
                    ///////////// the user can now access the different services of the web page
                    //System.out.println(webServicesMenuMessage);
                    switch (key) {
                        case 1: ///////////// the user wants to pay a debt
                            ArrayList<String[]> debts = caja.getSomeonesDebts(userID);
                            paying = true;
                            while (paying){
                                System.out.println("\nSu balance actual en su cuenta es de $"+caja.getSomeonesBalance(userID)+" pesos");
                                int totalDebts = caja.printSomeonesDebts(userID);
                                System.out.println(Integer.toString(totalDebts+1)+" Volver atras");
                                System.out.println("\nElija a quien quiere pagar\n"); 
                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                input = keyboardInput.readLine();      
                                while (!(Integer.valueOf(input)>0) || !(Integer.valueOf(input) <= debts.size()+1)){
                                    System.out.println("Por favor ingrese una opcion valida");
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                }
                                int cont = 0;
                                // This while cycle implements an indefinite version of the "select an option"
                                while (cont <= debts.size()){
                                    if (Integer.toString(cont).equals(input)){
                                        System.out.println("Ingrese el monto que desea pagar a " + debts.get(cont-1)[0] + "\n"); 
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        insideWhileInput = keyboardInput.readLine(); 
                                        caja.managePayment(Integer.toString(user.getTUI().getID()),debts.get(cont-1)[0], Integer.valueOf(insideWhileInput));
                                    }
                                    cont ++;
                                }
                                paying = false;
                            }
                            break;
                        case 2: ///////////// the user wants to rent a court
                            renting = true;
                            while (renting){
                                int totalcourts = torre.printCourts();
                                System.out.println(Integer.toString(totalcourts+1)+" Volver atras");
                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                input = keyboardInput.readLine();      
                                while (!(Integer.valueOf(input)>0) || !(Integer.valueOf(input) <= totalcourts+1)){
                                    System.out.println("Por favor ingrese una opcion valida");
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                }
                                int cont = 0;
                                // This while cycle implements an indefinite version of the "select an option"
                                while (cont <= totalcourts){
                                    if (Integer.toString(cont).equals(input)){
                                        System.out.print("Elija el horario en que quiere reservar la cancha " + torre.getCourt(Integer.valueOf(input)-1));
                                        System.out.print(horariosCancha);
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        insideWhileInput = keyboardInput.readLine();      
                                        while (Integer.valueOf(insideWhileInput)<0 || Integer.valueOf(insideWhileInput)>14){
                                            System.out.println("Por favor ingrese una opcion valida");
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            insideWhileInput = keyboardInput.readLine();
                                        }
                                        int hora = Integer.valueOf(insideWhileInput)+8;
                                        System.out.print("Elija el dia en que quiere reservar la cancha");
                                        System.out.print(diasSemana);
                                        System.out.print("7 - Cancelar\n");
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        insideWhileInput = keyboardInput.readLine();      
                                        while (!insideWhileInput.equals("1") && !insideWhileInput.equals("2") && !insideWhileInput.equals("3") && !insideWhileInput.equals("4") && !insideWhileInput.equals("5") && !insideWhileInput.equals("6") && !insideWhileInput.equals("6")){
                                            System.out.println("Por favor ingrese una opcion valida");
                                            keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                            insideWhileInput = keyboardInput.readLine();
                                        }
                                        int dia = Integer.valueOf(insideWhileInput);
                                        System.out.println(torre.getFormattedDate(LocalDateTime.now(), hora, dia));
                                        torre.reservateCourt(LocalDateTime.now(), torre.getCourt(cont-1), user.getName(), userID, torre.getFormattedDate(LocalDateTime.now(), hora, dia));
                                    }
                                    cont ++;
                                }
                                renting = false;
                            }
                            break;
                        case 3: //Horas
                            int horas = placeres.getHoursOnCampus(LocalDateTime.now(), userID);
                            System.out.println("Usted ha invertido hasta ahora " + Integer.toString(horas) + " horas en el campus");
                            break;
                        case 4: //salir
                            status = MachineState.WEBLOG;
                            break;
                        default: System.out.println("Por favor ingrese una opcion valida");
                            break;
                    }
                    */
                    break;
            
                case SIMOUTSIDE: ///////////// the simulations starts, the student is outside the campus
                    screen.setVisiblePanel("SimulationOut");
                    status = screen.getStatus();
                    //System.out.println("Bienvenido/a "+user.getName());
                    /*while (status == MachineState.SIM){
                        System.out.println(simulationMenuMessage);
                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                        input = keyboardInput.readLine();
                        nextStage = false;
                        key = Integer.parseInt(input);
                        switch (key) {
                            case 1: // Placeres
                                placeres.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                nextStage = true;
                                break;
                            case 2: // Portales
                                portales.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                nextStage = true;
                                break;
                            case 3: // España
                                valdes.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                nextStage = true;
                                break;
                            case 4: // Valdes
                                espania.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                nextStage = true;
                                break;
                            case 5: // menu principal
                                status = MachineState.SIMLOG;
                                nextStage = false;
                                break;
                            default: System.out.println("Por favor ingrese una opcion valida");
                                break;
                        }
                        
                        if (nextStage){
                            simInsideTheCampus = true;
                            while (simInsideTheCampus){
                                nextStage = false;
                                ///////////// the user was able to enter the university throught any entrance
                                System.out.println(simulationMessageInsideCampus);
                                keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                input = keyboardInput.readLine();
                                while (!input.equals("1") && !input.equals("2")){
                                    System.out.println("Por favor ingrese una opcion valida");
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                }
                                if (input.equals("1")){
                                    ///////////// the user goes to some sports court
                                    System.out.println(simulationSelectSportsCourtMessage);
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                    while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4")){
                                        System.out.println("Por favor ingrese una opcion valida");
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        input = keyboardInput.readLine();
                                    }
                                    if (input.equals("1")){
                                        System.out.println(torre.markAsistence(String.valueOf(user.getTUI().getID()), LocalDateTime.now(), "c5x5", 10, 1500));
                                    }
                                    else if (input.equals("2")){
                                        System.out.println(torre.markAsistence(String.valueOf(user.getTUI().getID()), LocalDateTime.now(), "c7x7", 10, 1500));
                                    }
                                    else if (input.equals("3")){
                                        System.out.println(torre.markAsistence(String.valueOf(user.getTUI().getID()), LocalDateTime.now(), "cpasto", 10, 1500));
                                    }
                                }
                                else if (input.equals("2")){
                                    ///////////// the user goes to an entrance with the objective to get outside the campus
                                    System.out.println(simulationLeavingCampusMenuMessage);
                                    keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                    input = keyboardInput.readLine();
                                    nextStage = false;
                                    while (!input.equals("1") && !input.equals("2") && !input.equals("3") && !input.equals("4") && !input.equals("5")){
                                        System.out.println("Por favor ingrese una opcion valida");
                                        keyboardInput = new BufferedReader(new InputStreamReader(System.in));
                                        input = keyboardInput.readLine();
                                    }
                                    if (input.equals("1")){
                                        placeres.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                        nextStage = true;
                                    }
                                    else if (input.equals("2")){
                                        portales.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                        nextStage = true;
                                    }
                                    else if (input.equals("3")){
                                        valdes.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                        nextStage = true;
                                    }
                                    else if (input.equals("4")){
                                        espania.registerEntryOrExit(LocalDateTime.now(), String.valueOf(user.getTUI().getID()),user.getTUI().getName());
                                        nextStage = true;
                                    }
                                    else if (input.equals("5")){
                                        nextStage = false;
                                    }
                                    if (nextStage){
                                        nextStage = false;
                                        simInsideTheCampus = false;
                                    }
                                }
                            }
                        }
                    }
                    */
                    break;
                case SIMINSIDE: ///////////// the simulations starts, the student is outside the campus
                    screen.setVisiblePanel("SimulationIn");
                    status = screen.getStatus();
                    break;
            
                default: System.exit(0); break;
            } 
        }
    }

    /**
     * @param state: states if is the web or sim menu
     * @return state: This method returns a message declaring the success of the registry
     */
    public static String[] LogIN(String state){
        String input = "";
        String[] answer = new String[2];
        answer[0] = state; // estado en el que se encuentra
        databaseManager TUI_database = new databaseManager("bases de datos/TUI dataBase");
        
        input = screen.getInput();
        ///////////// if login is successful
        if (TUI_database.lookForID(input).length>0){
            answer[1] = input;
            screen.validateInput(true);
        }
        ///////////// if not
        else{
            answer[1] = "";
            screen.validateInput(false);
        } 
        return answer;
    }

    /**
     * @param nothing
     * @return void: This method inputs the registry into the database
     */
    public static void Register(String [] input){
        ///////////// this is the page's Register
        String newID, name, fecha, mail;
        String delimiter = "/";
        String[] temp;
        int dd,mm,aaaa;
        int num;
        person user;
        databaseManager TUI_database = new databaseManager("bases de datos/TUI dataBase");

        name = input[0];
        System.out.println("Su nombre es: "+name);
        fecha = input[1];
        temp = fecha.split(delimiter);
        dd = Integer.parseInt(temp[0]);
        mm = Integer.parseInt(temp[1]);
        aaaa = Integer.parseInt(temp[2]);
        System.out.println("La fecha es: "+dd+" del "+mm+" de "+aaaa);
        mail = input[2];
        System.out.println("El correo es: "+mail);
        
        do {
        num = (int) (Math.random() * 89999) + 10000;
        newID = "2019"+num;
        } while (TUI_database.lookForID(newID).length>0);

        System.out.println("Su nuevo ID es: "+newID);
        String[] data = new String[] {newID,name,mail,"0","5000","0"};
        TUI_database.pushInfo(data);
        System.out.println("Registro Satisfactorio\n");

        screen.validateInput(true);
    } 
}
