import java.time.*;
import java.util.ArrayList;

public class bank extends structModel{
    private databaseManager users;
    
    /////////////////////////////// Inicializators    
    public bank(String nombre,float pos_x,float pos_y, databaseManager baseDeDatos, databaseManager usuarios){
        super(nombre,pos_x,pos_y,baseDeDatos);
        users = usuarios;
    }
    
    /////////////////////////////// Methods

    /**
     * @param whichOne String: "Bank database" or "TUI database", any other string will return null
     * @return databaseManager: This method returns a databaseManager of this instance
     */
    public databaseManager getDatabaseManager(String whichOne) {
        if (whichOne.equals("Bank database")){
            return super.database;
        }
        else if (whichOne.equals("TUI database")){
            return users;
        }
        else{
            return null;
        }
    }
    
    /**
     * @param ID The ID of the user
     * @param Charger The name of the institution that the user owe's money to
     * @param money The amount of money that the user want's to pay to the Charger 
     * @return void: This method registers a debt asked by a Charger (someone you owe money to)
     */
    public void addDebt(String ID, String Charger, int money){
        int[] linesWithCharger = this.getDatabaseManager().lookForID(Charger, 1);
        int[] linesWithThisID = this.getDatabaseManager().lookForID(ID, 0);
        boolean isInThere = false;
        int line = 0;
        for (int withCharger:linesWithCharger){
            for (int withThisID:linesWithThisID){
                if (withCharger == withThisID){
                    isInThere = true;
                    line = withCharger;
                }
            } 
        }
        if (isInThere){
            String[] datos = this.getDatabaseManager().pullInfo(line);
            money = money + Integer.valueOf(datos[2]);
            this.getDatabaseManager().deleteInfo(line);
        }
        this.getDatabaseManager().appendInfo(new String[] {ID, Charger, String.valueOf(money)});
    }

    public int getSomeonesBalance(String ID){
        return Integer.valueOf(users.pullInfo(ID)[5]);
    }

    /**
     * @param ID The ID of the user
     * @return ArrayList<String[]>: This function return's an array of elements of the type [String <Charger>, String <Total debt to this charger>] 
     */
    public ArrayList<String[]> getSomeonesDebts(String ID){ // charger is the one you owe money to. I did not found a better word.
        int[] positions;
        String[] data; 
        int totalDebt = 0;
        boolean isInThere = false;
        int whereIsIt = 0;
        ArrayList<String[]> debtsResume = new ArrayList<String[]>();

        positions = this.getDatabaseManager().lookForID(ID);
        
        // reads every line where the person has a debt.
        for (int pos:positions){
            data = this.getDatabaseManager().pullInfo(pos);
            totalDebt = totalDebt + Integer.valueOf(data[2]);

            // at the end of this cycle we will have a list of strins Arrays of the type [Charger, Total debt to this charger]
            for (String[] Charger:debtsResume){
                if (Charger[0].equals(data[1])) isInThere = true;
                if (isInThere) whereIsIt++;
            }
            if (!isInThere){
                debtsResume.add(new String[] {data[1],data[2]});
            }
            else{
                debtsResume.add(whereIsIt, new String[] {data[1],Integer.toString(Integer.valueOf(data[2])+Integer.valueOf(debtsResume.get(whereIsIt)[0]))});
            }
        }
    return debtsResume;
    }

    /**
     * @param ID The ID of the user
     * @return int: This function will return the amount of debts of the user asociated to the ID
     */
    public int printSomeonesDebts(String ID){
        ArrayList<String[]> debts = getSomeonesDebts(ID);
        int cont = 0;
        System.out.println("\n");
        for (String[] debt:debts){
            cont ++;
            System.out.println(Integer.toString(cont) + " " + debt[0]+": $"+debt[1]);
        }
        return cont;
    }

    /**
     * @param ID The ID of the user
     * @return int: This function will return the amount of debts of the user asociated to the ID
     */
    public int printSomeonesDebtsOnStr(String ID){
        ArrayList<String[]> debts = getSomeonesDebts(ID);
        int cont = 0;
        System.out.println("\n");
        String acc = "";
        for (String[] debt:debts){
            acc = acc + Integer.toString(cont) + " " + debt[0]+": $"+debt[1] + "\n";
        }
        return cont;
    }

    /**
     * @param ID The ID of the user
     * @param Charger The name of the institution that the user owe's money to
     * @param money The amount of money that the user want's to pay to the Charger 
     * @return void: This function substracts a money ammount that the user payed to some Charger 
     */
    public void managePayment(String ID, String Charger, int money){
        int[] linesWithCharger = this.getDatabaseManager().lookForID(Charger, 1);
        int[] linesWithThisID = this.getDatabaseManager().lookForID(ID, 0);
        boolean isInThere = false;
        int line = 0;
        if (money <= Integer.valueOf(users.pullInfo(ID)[5])){ 
            for (int withCharger:linesWithCharger){
                for (int withThisID:linesWithThisID){
                    if (withCharger == withThisID){
                        isInThere = true;
                        line = withCharger;
                    }
                } 
            }                                    
            if (isInThere){
                String[] datos = this.getDatabaseManager("Bank database").pullInfo(line);
                int newDebt = Integer.valueOf(datos[2]) - money;
                if (newDebt < 0){
                    System.out.println("No se permite pagar mas de lo que debe\nOperacion cancelada\n");    
                }
                else{
                    this.getDatabaseManager("Bank database").deleteInfo(line);
                    if (newDebt > 0) this.getDatabaseManager("Bank database").appendInfo(new String[] {ID, Charger, String.valueOf(newDebt)}); 
                    String[] usuario = this.getDatabaseManager("TUI database").pullInfo(ID);
                    this.getDatabaseManager("TUI database").deleteInfo(ID);
                    this.getDatabaseManager("TUI database").appendInfo(new String[] {usuario[0], usuario[1], usuario[2], usuario[3], usuario[4], String.valueOf(Integer.valueOf(usuario[5])-money)}); 
                }
            }
            else System.out.println("Usted no debe nada a "+ Charger +"\n");
        }
        else System.out.println("Usted no cuenta con fondos suficientes para realizar esta operacion\n");
    }
}