import java.time.*;

public class courtsOffice extends structModel{
    private boolean c5x5;
    private boolean c7x7;
    private boolean cp;
    private String[] courts = new String[] {"c5x5", "c7x7", "cp"};
    private bank bk;
    
    /////////////////////////////// Inicializators    
    public courtsOffice(String nombre,float pos_x,float pos_y, databaseManager baseDeDatos, boolean C5x5, boolean C7x7, boolean Cp, bank banco){
        super(nombre,pos_x,pos_y,baseDeDatos);
        this.c5x5 = C5x5;
        this.c7x7 = C7x7;
        this.cp = Cp;
        this.bk = banco;
    }
    
    /////////////////////////////// Methods

    /**
     * @return int: This method prints a list of every court and returns the number of courts avilable
     */
    public int printCourts(){
        int cont = 0;
        System.out.println("\nSeleccione la cancha que desea arrendar");
        for (String court:courts){
            cont ++;
            System.out.println(Integer.toString(cont) + " " + court);
        }
        return cont;
    }

        /**
     * @param index String: The index of a court on courts array
     * @return String: This method returns a court name
     */
    public String getCourt(int index){
        return courts[index];
    }

    /**
     * @param now LocalDateTime: The current time
     * @param courtName String: The name of the court that the user wants to reserve 
     * @param name String: The name of the user  
     * @param ID String: The ID of the user
     * @param when String: The date when the user want's to use that court, on format HH:MM-DD/MM/AAAA
     * @return void: This method checks if a court can be rented, and if so, writes it on the database. On error this method will printwhy the court can not be rented
     */
    // this method will get a reservation of a court if all conditions are met. those are:
    //  -that court is not rented by another person at that time
    //  -that person has no debts with this institution
    //  -that person has not anoter reservation on the reservations sheet
    //  -the reservation is not done for the past

    public void reservateCourt(LocalDateTime now, String courtName, String name, String ID, String when){
        String codeID = "";
        String formattedDate = "";
        String[] whenDayTime;
        String[] whenDay;
        String[] whenTime;

        whenDayTime = when.split("-");
        whenTime = whenDayTime[0].split(":");
        whenDay = whenDayTime[1].split("/");

        if (this.isInTheFuture(when,now) && this.hasNotAnotherReservation(ID) && !this.hasAnyDebtToUs(ID) && this.courtIsAvilable(courtName,when)){
            codeID = codeID + String.valueOf(now.getYear());
            if (now.getMonthValue()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getMonthValue());
            if (now.getDayOfMonth()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getDayOfMonth());
            if (now.getHour()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getHour());
            if (now.getMinute()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getMinute());
            if (now.getSecond()<10) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getSecond());
            if (now.getNano()/100000<10) codeID = codeID + "0";
            if (now.getNano()/100000<100) codeID = codeID + "0";
            if (now.getNano()/100000<1000) codeID = codeID + "0";
            codeID = codeID + String.valueOf(now.getNano()/100000);


            if (now.getHour()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getHour()) + ":";
            if (now.getMinute()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getMinute()) + ":";
            if (now.getDayOfMonth()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getDayOfMonth())+ "/";
            if (now.getMonthValue()<10) formattedDate = formattedDate + "0";
            formattedDate = formattedDate + String.valueOf(now.getMonthValue())+ "/";
            formattedDate = formattedDate + String.valueOf(now.getYear());

            this.getDatabaseManager().pushInfo(new String[] {codeID, formattedDate, when, courtName, name, ID});
        }
        else {
            System.out.println("\nNo se puede arrendar");
            if (!this.isInTheFuture(when,now)) System.out.println("Esta intentando arrendar para una fecha pasada");
            if (!this.hasNotAnotherReservation(ID)) System.out.println("Usted ya posee una reservacion");
            if (this.hasAnyDebtToUs(ID)) System.out.println("Usted posee deudas con la administracion");
            if (!this.courtIsAvilable(courtName,when)) System.out.println("La cancha ya esta pedida en ese horario");
        }
    }

    /**
     * @param courtName String The name of the court that the user wants to reserve 
     * @param when String The date when the user want's to use that court
     * @return void: this method checks if the court is rented by another person at some time
     */
    private boolean courtIsAvilable(String courtName, String when){
        int[] reservationsAtThatHour;
        reservationsAtThatHour = this.getDatabaseManager().lookForID(when, 2);
        for (int i : reservationsAtThatHour) {
            if (this.getDatabaseManager().pullInfo(i)[3].equals(courtName)) return false;
        }
        return true;
    }

    /**
     * @param now LocalDateTime: The current time
     * @param courtName String: The name of the court that the user wants to reserve 
     * @param name String: The name of the user  
     * @param ID String: The ID of the user
     * @param when String: The date when the user want's to use that court
     * @return boolean: This method checks if a date is or not at the future and terurns True if it do is on the future
     */
    private boolean isInTheFuture(String when,LocalDateTime now){
        String[] whenDayTime;
        String[] whenDay;
        String[] whenTime;
        long whenInMinutes;
        long nowInMinutes;

        whenDayTime = when.split("-");
        whenTime = whenDayTime[0].split(":");
        whenDay = whenDayTime[1].split("/");

        whenInMinutes = Integer.valueOf(whenDay[2])*60*60*24*30*12 + Integer.valueOf(whenDay[1])*60*60*24*30 + Integer.valueOf(whenDay[0])*60*60*24;
        whenInMinutes = whenInMinutes + Integer.valueOf(whenTime[0])*60*60 + Integer.valueOf(whenTime[1])*60;

        nowInMinutes = now.getYear()*60*60*24*30*12 + now.getMonthValue()*60*60*24*30 + now.getDayOfMonth()*60*60*24;
        nowInMinutes = nowInMinutes + now.getHour()*60*60 + now.getMinute()*60;

        if (whenInMinutes > nowInMinutes) return true;
        return false;
    }

    /**
     * @param when String: The date when the user want's to use that court
     * @param now LocalDateTime: The current time
     * @param nowOffsetInMinutes int: A string applied to move now on the temporal line.
     * @return boolean: This methdod checks if a date is or not at the future, giving the present some minute offset
     */
    private boolean isInTheFuture(String when,LocalDateTime now, int nowOffsetInMinutes){
        String[] whenDayTime;
        String[] whenDay;
        String[] whenTime;
        long whenInMinutes;
        long nowInMinutes;

        whenDayTime = when.split("-");
        whenTime = whenDayTime[0].split(":");
        whenDay = whenDayTime[1].split("/");

        whenInMinutes = Integer.valueOf(whenDay[2])*60*60*24*30*12 + Integer.valueOf(whenDay[1])*60*60*24*30 + Integer.valueOf(whenDay[0])*60*60*24;
        whenInMinutes = whenInMinutes + Integer.valueOf(whenTime[0])*60*60 + Integer.valueOf(whenTime[1])*60;

        nowInMinutes = now.getYear()*60*60*24*30*12 + now.getMonthValue()*60*60*24*30 + now.getDayOfMonth()*60*60*24;
        nowInMinutes = nowInMinutes + now.getHour()*60*60 + now.getMinute()*60 + nowOffsetInMinutes;

        if (whenInMinutes > nowInMinutes) return true;
        return false;
    }

    /**  
     * @param ID String: The ID of the user
     * @return boolean: This methdod returns true if the user's ID  does not hava any other reservation
     */
    private boolean hasNotAnotherReservation(String ID){
        if (getDatabaseManager().lookForID(ID,5).length == 0) return true;
        return false;
    }

    /**
     * @param ID String: The ID of the user
     * @param now LocalDateTime: The current time
     * @param courtName String: The name of the court that the user wants to reserve 
     * @param offsetInMinutes int: A string applied to move now on the temporal line
     * @param latePenalty int: the penalty that will be chargedif the user is late 
     * @return String: This methdod returns a String that tells what hapens when the user marks asistence
     */
    public String markAsistence(String ID, LocalDateTime now, String courtName, int offsetInMinutes, int latePenalty){
        String[] reservation;

        if (getDatabaseManager().lookForID(ID,5).length == 0) return "Usted no tiene ninguna cancha reservada";
        reservation = getDatabaseManager().pullInfo(getDatabaseManager().lookForID(ID,5)[0]);
        if (reservation[3].equals(courtName)){
            if (!this.isInTheFuture(reservation[2], now, -offsetInMinutes)){ // this is true if the person arrives too late to the reserved court
                this.getDatabaseManager().deleteInfo(this.getDatabaseManager().lookForID(ID, 5)[0]);
                bk.addDebt(ID,this.getBuildingsName(),latePenalty);
                this.getDatabaseManager().deleteInfo(reservation[0]);
                return "Ha llegado tarde, se cursa una multa de $"+ String.valueOf(latePenalty) +". Antes de poder volver a arrendar una cancha primero debera cancelar odas sus deudas con la Torre.";
            }
            else{
                if (!this.isInTheFuture(reservation[2], now, offsetInMinutes) && this.isInTheFuture(reservation[2], now, -offsetInMinutes)){ 
                    // this is true if the person arrives a little earlier, at time or a little late
                    this.getDatabaseManager().deleteInfo(this.getDatabaseManager().lookForID(ID, 5)[0]);
                    return "Ha llegado a tiempo, disfrute.";
                }
                else{
                    // this will be executed if the person checks the court too early
                    return "Ha marcado demasiado temprano, vuelva a inentar cerca de las "+reservation[2]+".";
                }
            }
        }
        return "Usted tiene reservada la cancha " + reservation[3] + ", esta es la "+courtName +".";
    }
    
    /**
     * @param ID String: The ID of the user
     * @return boolean: This method will check if a person owes money to the courtsOffice
     */
    public boolean hasAnyDebtToUs(String ID){
        int[] deudasID;
        String[] datosDeudaID;

        deudasID = bk.getDatabaseManager().lookForID(ID);
        for (int i : deudasID) {
            datosDeudaID = bk.getDatabaseManager().pullInfo(i);
            if (datosDeudaID[1].equals(this.getBuildingsName())) return true;
        }
        return false;
    }
    
    /**
     * @param ID String: The ID of the user
     * @param hora int: The hour option chosen by the user
     * @param dia int: the number of the day of the week, where monday is 1
     * @return String: the date when the user wants to use the court, on format HH:MM-dd/mm/aa
     */
    public String getFormattedDate(LocalDateTime now, int hora, int dia){
        String formato = "";
        if (hora<10) formato = "0" + Integer.toString(hora) + ":00-";
        else formato = Integer.toString(hora) + ":00-";
        if (now.getDayOfWeek().getValue() > dia) dia = dia + 7;
        dia = dia - now.getDayOfWeek().getValue();
        int diaMes = now.getDayOfMonth()+dia;
        int maxDias = 0;
        switch (now.getMonthValue()){
            case 1: maxDias = 31;
                    break;
            case 2: maxDias = 28;
                    break;
            case 3: maxDias = 31;
                    break;
            case 4: maxDias = 30;
                    break;
            case 5: maxDias = 31;
                    break;
            case 6: maxDias = 30;
                    break;
            case 7: maxDias = 31;
                    break;
            case 8: maxDias = 31;
                    break;
            case 9: maxDias = 30;
                    break;
            case 10: maxDias = 31;
                    break;
            case 11: maxDias = 30;
                    break;
            case 12: maxDias = 31;
                    break;
            default: maxDias = 30;
        }
        if (diaMes > maxDias){
            diaMes = diaMes - maxDias;
            formato = formato + Integer.toString(diaMes)+"/"+Integer.toString(now.getMonthValue()+1)+"/"+Integer.toString(now.getYear());
            return formato;
        }
        formato = formato + Integer.toString(diaMes)+"/"+Integer.toString(now.getMonthValue())+"/"+Integer.toString(now.getYear());
        return formato;
        
    }
}