import java.util.Scanner;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

class databaseManager implements ActionListener{    // implements the ActionListener to be able to try/catch

    /////////////////////////////// Parameters
    private String filename;
    private Scanner file;

    /////////////////////////////// Inicializators
    public databaseManager(String nombreArchivo){
        this.filename = nombreArchivo;
    }

    /////////////////////////////// Methods

    /**
     * @param ID String: The ID of the user
     * @return int[]: This method will return an array with all the lines that starts with ID
     */
    public int[] lookForID(String ID){
        int lineCounter = 0;
        int[] linesFounded;
        String linesFoundedStr = "";
        boolean open = false;
        boolean completelyReaded = false;
        int timesFounded;

        while (!completelyReaded){
            try {
                if (!open){                                                 // This will open the file the first time
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                    lineCounter = 0;
                }
                if (file.hasNextLine()) {                                   // This will get line by line of the file at the end  
                    String line = file.nextLine();
                    lineCounter++;
                    String[] personalData = line.split("_");
                    if (ID.equals(personalData[0])){                        
                        if (linesFoundedStr == "") linesFoundedStr = Integer.toString(lineCounter);
                        else linesFoundedStr = linesFoundedStr + "_" + Integer.toString(lineCounter);
                    }
                }
                else{                                                       // This will close the file at the end
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        if (linesFoundedStr.contains("_")) timesFounded = linesFoundedStr.split("_").length;
        else if (!linesFoundedStr.contains("_") && linesFoundedStr.length()>0) timesFounded = 1;
        else timesFounded = 0;
        linesFounded = new int[timesFounded];
        for(int i = 0;i < timesFounded;i++){
            String a = linesFoundedStr.split("_")[i];
                linesFounded[i] = Integer.parseInt(linesFoundedStr.split("_")[i]);
        }
        return linesFounded;
    }

    /**
     * @param ID String: The ID of the user
     * @param position int: the index of the data that is being looked
     * @return int[]: This method will return an array with all the lines that have the ID on an specific field
     */
    public int[] lookForID(String ID, int position){
        int isInThere = 1;
        int[] linesFounded;
        String linesFoundedStr = "";
        String line;
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        int timesFounded;

        while (!completelyReaded){
            try {
                if (!open){                                                     // This will open the file the first time
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                    isInThere = 1;
                }
                if (file.hasNextLine()) {                                       // This will get line by line of the file at the end  
                    line = file.nextLine();
                    personalData = line.split("_");
                    if (ID.equals(personalData[position])){
                        if (linesFoundedStr == "") linesFoundedStr = Integer.toString(isInThere);
                        else linesFoundedStr = linesFoundedStr + "_" + Integer.toString(isInThere);
                    }
                    isInThere++;
                }
                else{                                                           // This will close the file at the end
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        if (linesFoundedStr.indexOf('_') != -1) timesFounded = linesFoundedStr.split("_").length;
        else{
            if (linesFoundedStr.equals("")) timesFounded = 0;
            else timesFounded = 1;
        }
        linesFounded = new int[timesFounded];
        for(int i = 0;i < timesFounded;i++){
            String a = linesFoundedStr.split("_")[i];
                linesFounded[i] = Integer.parseInt(linesFoundedStr.split("_")[i]);
        }
        return linesFounded;
    }

    /**
     * @param ID String: The ID of the user
     * @return String[]: This method will return an array with the data of the first line of the file that starts with the ID
     */
    public String[] pullInfo(String ID) {
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        String line;
        while (!completelyReaded){
            try {
                if (!open){                                            
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                           
                    line = file.nextLine();
                    personalData = line.split("_");
                    if (ID.equals(personalData[0])){
                        file.close();
                        return personalData;
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        personalData = new String[] {""};
        return personalData;
    }

    /**
     * @param lineIndex int: The numbr of the line that has the information 
     * @return String[]: This method will return an array with the data of the specified line of the file
     */
    public String[] pullInfo(int lineIndex) {
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        int lineCounter = 0;
        String line;
        while (!completelyReaded){
            try {
                if (!open){                                              
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                          
                    line = file.nextLine();
                    lineCounter++;
                    if (lineCounter == lineIndex){
                        personalData = line.split("_");
                        file.close();
                        return personalData;
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        personalData = new String[] {""};
        return personalData;
    }

    /**
     * @param data String[]: An array with the data that has to be written on the file 
     * @return void: This method will write some data on the file, keeping the file sorted by the first element of data
     */
    public void pushInfo(String[] data) {
        String newFileData = "";
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        boolean changeExcecuted = false;
        FileWriter writer = null;

        while (!completelyReaded){
            try {
                if (!open){                                                
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                  
                    String line = file.nextLine();
                    personalData = line.split("_");
                    if (Long.parseLong(data[0]) > Long.parseLong(personalData[0]) && !changeExcecuted){ 
                        newFileData = newFileData + line + "\n";
                    }
                    if (Long.parseLong(data[0]) < Long.parseLong(personalData[0]) && !changeExcecuted){
                        newFileData = newFileData + String.join("_", data) + "\n";
                        changeExcecuted = true;
                    }
                    if (Long.parseLong(data[0]) == Long.parseLong(personalData[0]) && !changeExcecuted){ 
                        newFileData = newFileData + String.join("_", data) + "\n";
                        changeExcecuted = true;
                    }
                    else if (changeExcecuted){ // este else if puede ejecutarse si se cumple el segundo if, pero no si se cumple el tercero
                        newFileData = newFileData + line + "\n";
                    }
                }
                else{
                    if (!changeExcecuted){
                        newFileData = newFileData + String.join("_", data) + "\n";
                    }
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        try{
            writer = new FileWriter(filename);
            writer.write(newFileData);
            writer.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * @param data String[]: An array with the data that has to be written on the file 
     * @return void: This method will write some data at the end of the document
     */
    public void appendInfo(String[] data) {
        String newFileData = "";
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        boolean changeExcecuted = false;
        FileWriter writer = null;

        while (!completelyReaded){
            try {
                if (!open){                                             
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                  
                    String line = file.nextLine();
                    newFileData = newFileData + line + "\n";
                }
                else{
                    newFileData = newFileData + String.join("_", data);
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        try{
            writer = new FileWriter(filename);
            writer.write(newFileData);
            writer.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * @param ID String: The ID of the user
     * @return void: This method will remove every line that starts with an ID
     */
    public void deleteInfo(String ID) {
        String newFileData = "";
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        FileWriter writer = null;

        while (!completelyReaded){
            try {
                if (!open){                                                
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                 
                    String line = file.nextLine();
                    personalData = line.split("_");
                    if (!ID.equals(personalData[0])){
                        newFileData = newFileData + line + "\n";
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        try{
            writer = new FileWriter(filename);
            writer.write(newFileData);
            writer.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /**
     * @param linea int: number of the line to be deleted
     * @return void: This method will remove a specified line from the file
     */
    public void deleteInfo(int linea) {
        String newFileData = "";
        String[] personalData;
        boolean open = false;
        boolean completelyReaded = false;
        FileWriter writer = null;
        int count = 0;

        while (!completelyReaded){
            try {
                if (!open){                                             
                    file = new Scanner(new File(filename));
                    open = true;
                    completelyReaded = false;
                }
                if (file.hasNextLine()) {                                   
                    String line = file.nextLine();
                    count++;
                    personalData = line.split("_");
                    if (count != linea){
                        newFileData = newFileData + line + "\n";
                    }
                }
                else{
                    file.close();
                    open = false;
                    completelyReaded = true;
                }
            }
            catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        try{
            writer = new FileWriter(filename);
            writer.write(newFileData);
            writer.close();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    //this method has to be overwritten
    public void actionPerformed(ActionEvent arg0) {

    }
}