import java.time.*;

public class entrance extends structModel{

    /////////////////////////////// Inicializators    
    public entrance(String nombre,float pos_x,float pos_y, databaseManager baseDeDatos){
        super(nombre,pos_x,pos_y,baseDeDatos);
        
    }
    
    /////////////////////////////// Methods    
    
    /**
     * @param now LocalDateTime: The actual time and hour
     * @param ID String: The ID of the user
     * @return void: This method will remove every line that starts with an ID
     */
    public void registerEntryOrExit(LocalDateTime now, String ID, String name){
        String codeID = "";
        String formattedDate = "";
        String direction;
        int[] previousTimes;
        int lastTime;

        //the following code will create a chronological ID, usefull for sort purposes (this was created before databaseManager.appendInfo())
        codeID = codeID + String.valueOf(now.getYear()); 
        if (now.getMonthValue()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getMonthValue());
        if (now.getDayOfMonth()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getDayOfMonth());
        if (now.getHour()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getHour());
        if (now.getMinute()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getMinute());
        if (now.getSecond()<10) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getSecond());
        if (now.getNano()/100000<10) codeID = codeID + "0";
        if (now.getNano()/100000<100) codeID = codeID + "0";
        if (now.getNano()/100000<1000) codeID = codeID + "0";
        codeID = codeID + String.valueOf(now.getNano()/100000);

        //the following code will create a formatted version of an hour, that will look like this: hh:mm-dd/mm/aaaa
        if (now.getHour()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getHour()) + ":";
        if (now.getMinute()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getMinute()) + "-";
        if (now.getDayOfMonth()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getDayOfMonth())+ "/";
        if (now.getMonthValue()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getMonthValue())+ "/";
        formattedDate = formattedDate + String.valueOf(now.getYear());

        // next code looks for the user's ID in the database to know if the user is inside or outside the campus. If no data, it assumes it's outside.
        previousTimes = this.getDatabaseManager().lookForID(ID, 5);
        if (previousTimes.length != 0){
            lastTime = previousTimes[previousTimes.length-1];
            if(this.getDatabaseManager().pullInfo(lastTime)[2].equals("Enter")) direction = "Exit";
            else direction = "Enter";
        }
        else direction = "Enter";
        this.getDatabaseManager().pushInfo(new String[] {codeID, this.getBuildingsName(), direction, formattedDate, name, ID});
    }

    /**
     * @param now LocalDateTime: The actual time and hour
     * @param ID String: The ID of the user
     * @return void: This method will remove every line that starts with an ID
     */
    public int getHoursOnCampus(LocalDateTime now,String ID){
        databaseManager data = this.getDatabaseManager();
        int[] lineas = data.lookForID(ID, 5);
        int horasTotales = 0;

        String fechaEntrada = "";
        String fechaSalida = "";

        int lastLine = lineas[lineas.length-1];

        String formattedDate = "";
        if (now.getHour()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getHour()) + ":";
        if (now.getMinute()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getMinute()) + "-";
        if (now.getDayOfMonth()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getDayOfMonth())+ "/";
        if (now.getMonthValue()<10) formattedDate = formattedDate + "0";
        formattedDate = formattedDate + String.valueOf(now.getMonthValue())+ "/";
        formattedDate = formattedDate + String.valueOf(now.getYear());

        for (int linea:lineas){
            String[] lin = data.pullInfo(linea);
            if (lin[2].equals("Enter")){
                fechaEntrada = lin[3];
                if (lastLine == linea){
                    fechaSalida = formattedDate;
                    int anio1 = Integer.valueOf(fechaEntrada.split("-")[1].split("/")[2]);
                    int anio2 = Integer.valueOf(fechaSalida.split("-")[1].split("/")[2]);
                    if (anio2 > anio1){
                        horasTotales = horasTotales + 365*24*60*(anio2-anio1);    
                    }
                    int mes1 = Integer.valueOf(fechaEntrada.split("-")[1].split("/")[1]);
                    int mes2 = Integer.valueOf(fechaSalida.split("-")[1].split("/")[1]);
                    if (mes2 > mes1){
                        horasTotales = horasTotales + 30*24*60*(mes2-mes1);    
                    }
                    int dia1 = Integer.valueOf(fechaEntrada.split("-")[1].split("/")[0]);
                    int dia2 = Integer.valueOf(fechaSalida.split("-")[1].split("/")[0]);
                    if (dia2 > dia1){
                        horasTotales = horasTotales + 24*60*(dia2-dia1);    
                    }
                    int hora1 = Integer.valueOf(fechaEntrada.split("-")[0].split(":")[0]);
                    int hora2 = Integer.valueOf(fechaSalida.split("-")[0].split(":")[0]);
                    if (hora2 > hora1){
                        horasTotales = horasTotales + 60*(hora2-hora1);    
                    }
                    int minuto1 = Integer.valueOf(fechaEntrada.split("-")[0].split(":")[1]);
                    int minuto2 = Integer.valueOf(fechaSalida.split("-")[0].split(":")[1]);
                    if (minuto2 > minuto1){
                        horasTotales = horasTotales + (minuto2-minuto1);    
                    }
                }
            }
            else{
                fechaSalida = formattedDate;
                int anio1 = Integer.valueOf(fechaEntrada.split("-")[1].split("/")[2]);
                int anio2 = Integer.valueOf(fechaSalida.split("-")[1].split("/")[2]);
                if (anio2 > anio1){
                    horasTotales = horasTotales + 365*24*60*(anio2-anio1);    
                }
                int mes1 = Integer.valueOf(fechaEntrada.split("-")[1].split("/")[1]);
                int mes2 = Integer.valueOf(fechaSalida.split("-")[1].split("/")[1]);
                if (mes2 > mes1){
                    horasTotales = horasTotales + 30*24*60*(mes2-mes1);    
                }
                int dia1 = Integer.valueOf(fechaEntrada.split("-")[1].split("/")[0]);
                int dia2 = Integer.valueOf(fechaSalida.split("-")[1].split("/")[0]);
                if (dia2 > dia1){
                    horasTotales = horasTotales + 24*60*(dia2-dia1);    
                }
                int hora1 = Integer.valueOf(fechaEntrada.split("-")[0].split(":")[0]);
                int hora2 = Integer.valueOf(fechaSalida.split("-")[0].split(":")[0]);
                if (hora2 > hora1){
                    horasTotales = horasTotales + 60*(hora2-hora1);    
                }
                int minuto1 = Integer.valueOf(fechaEntrada.split("-")[0].split(":")[1]);
                int minuto2 = Integer.valueOf(fechaSalida.split("-")[0].split(":")[1]);
                if (minuto2 > minuto1){
                    horasTotales = horasTotales + (minuto2-minuto1);    
                }
            }
        }
        System.out.println(Integer.toString(horasTotales));
        horasTotales = horasTotales/60;
        return horasTotales;
    }
}